SystemOrganization addCategory: #ConfigurationOfMutationEngine!

Object subclass: #ConfigurationOfMutationEngine
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMutationEngine'!

!ConfigurationOfMutationEngine class methodsFor: 'development support' stamp: 'ag 9/6/2012 14:05:12.057'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMutationEngine class methodsFor: 'private' stamp: 'ag 9/6/2012 14:05:12.095'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMutationEngine class methodsFor: 'private' stamp: 'ag 9/6/2012 14:05:12.113'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMutationEngine class methodsFor: 'private' stamp: 'ag 9/6/2012 14:05:12.131'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMutationEngine class methodsFor: 'metacello tool support' stamp: 'ag 9/6/2012 14:05:12.151'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMutationEngine class methodsFor: 'loading' stamp: 'ag 9/6/2012 14:05:12.168'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMutationEngine class methodsFor: 'loading' stamp: 'ag 9/6/2012 14:05:12.186'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMutationEngine class methodsFor: 'loading' stamp: 'ag 9/6/2012 14:05:12.204'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMutationEngine class methodsFor: 'accessing' stamp: 'ag 9/6/2012 14:05:12.221'!
project

	^self new project! !

!ConfigurationOfMutationEngine class methodsFor: 'development support' stamp: 'ag 9/6/2012 14:05:12.075'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMutationEngine methodsFor: 'baselines' stamp: 'ag 9/6/2012 14:48:34.086'!
baseline100: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		
		spec
			project: 'Refactoring-Core' with: [
				spec
					className: 'ConfigurationOfRefactoringBrowser';
					loads: #( 'Core' );
					file: 'ConfigurationOfRefactoringBrowser';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		
		spec package: 'OCForOB' with: [ 
			spec
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities' ].
		
		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MutationEngine'.
		spec 
			package: 'MutationEngine';
			package: 'MutationEngine-Tests' with: [ spec requires: 'MutationEngine' ]
		].! !

!ConfigurationOfMutationEngine methodsFor: 'accessing' stamp: 'ag 9/6/2012 14:05:11.746'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMutationEngine methodsFor: 'versions' stamp: 'ag 9/6/2012 14:10:14.933'!
version100: spec 
	<version: '1.0' imports: #('1.0-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'Example-Core' with: 'Example-Core-DaleHenrichs.1';
			package: 'Example-Tests' with: 'Example-Tests-DaleHenrichs.1'].! !
